Subject: Re: bug#18996: 24.4; Pressing Alt-g shows Esc g- when running emacs inside terminal and in GUI mode it shows M-g

From: Eli Zaretskii <[email-masked]>
Date: Sat, 05 Mar 2016 20:52:14 +0200

> From: Marcin Borkowski <[email-masked]>
> Date: Sat, 05 Mar 2016 19:14:17 +0100
> Cc: [email-masked]
> 
> > When I press Alt-g as part of executing the shortcut M-g g, when running
> > emacs within the terminal using the -nw flag, it shows up in the
> > minibuffer as "Esc g-". But when I run the same in the GUI Emacs, it
> > shows up as "M-g". This can be misleading and confusing to users who do
> > not know Esc and Meta keys are equivalent.
> 
> Confirmed on GNU Emacs 25.1.50.6 (commit ac9a931).
> 
> > Further, when I press Alt-x, it shows up as M-x in both the
> > scenarios. So it doesn't look like Emacs cannot differentiate between
> > the two when running inside the terminal without a GUI.
> 
> This is not true: M-x is bound (by default) to
> `execute-extended-command', which calls `read-extended-command', which
> has at one point the literal string "M-x ", which is fed (via
> a `concat', which shows prefix arguments, if any) directly to
> `completing-read'.
> 
> > I vaguely remember seeing M-g in the terminal on pressing Alt-g some
> > time back, maybe in an older emacs version. But not sure.
> 
> No idea, though I doubt.
> 
> All in all, I'll assign this a "wishlist" level - I agree with the OP
> that it would be nice to have this solved

To have what solved?

If you type "C-h l" after M-x, what do you see?